<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<!-- Font Awesome -->
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Album</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Album</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-album-code" placeholder="Album code" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Tên Album</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-album-name" placeholder="Album name" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Mô tả</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div class="col-sm-12">
					<button id="save_data" class="btn btn-info">Save Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã Album</th>
					<th>Tên Album</th>
					<th>Mô tả</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
					<th>Action</th>
					<th>Danh sách Pictures</th>
				</tr>
		</table>
	</div>
	<!-- Update Order modal -->
	<div>
		<div id="update-album-modal" class="modal fade" tabindex="-1">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Update Trạng Thái Album</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<form>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Mã Album</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-maalbum" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Tên Album</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-tenalbum" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Mô tả</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-moTa" class="form-control">
								</div>
							</div>
						</form>
					</div>
					<div class="modal-footer">
						<button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
						<button class="btn btn-primary" id="btn-update-album">Update Trạng Thái</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- Delete confirm modal -->
	<div>
		<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Album Delete Confirmation</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<label>Bạn có chắc chắn muốn xóa Album này không?</label>
					</div>
					<div class="modal-footer">
						<button class="btn btn-danger" id="btn-confirm-delete-album">Confirm</button>
						<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<script>
		$(document).ready(function () {
			var gAlbum_code = {
				id: "",
			}
			onPageLoading();
			$("#save_data").on("click", function () {
				onButtonCreateClick(); // this là button được ấn
			});
			// khi ấn sự kiện edit
			$("#user-table").on("click", ".edit-album", function () {
				onButtonChiTietClick(this); // this là button được ấn
			});
			// khi ấn nút sự kiện update trên modal
			$("#btn-update-album").on("click", function () {
				onBtnUpdateClick();
			});
			// khi ấn sự kiện delete
			$("#user-table").on("click", ".delete-album", function () {
				onBtnDeleteConfirmOrderClick(this);
			});
			// khi ấn sự kiện delete
			$("#user-table").on("click", ".btn-pictures", function () {
				onBtnPicturesConfirmOrderClick(this);
			});
			// gán sự kiện cho nút Delete  (trên modal)
			$("#btn-confirm-delete-album").on("click", function () {
				onBtnDeleteVoucherClick();
			});
			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "albumCode" },
					{ "data": "albumName" },
					{ "data": "moTa" },
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
					{ "data": "action" },
					{ "data": "dspictures" },
				],
				columnDefs: [
					{
						targets: 6,
						defaultContent: '<i class="fas fa-pen text-info edit-album"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-album"></i>'
					},
					{
						targets: 7,
						defaultContent: '<button class="btn btn-primary btn-pictures">Danh sách Pictures</button>'
					}
				]
			})
			function onPageLoading() {
				$.ajax({
					url: "http://localhost:8080/albums",
					type: "GET",
					dataType: "json",
					success: function (res) {
						console.log(res);
						table.clear();
						table.rows.add(res);
						table.draw();
					},
					error: function (err) {
						console.log(err.response);
					}
				})
			}
			// Hàm sự kiện thêm voucher
			function onButtonCreateClick() {
				// khai báo dữ liệu
				var vAlbumObj = {
					albumCode: "",
					albumName: "",
					moTa: ""
				}
				// thu thập thông tin 
				getCreateData(vAlbumObj);
				// validate
				if (kiemtraCreateData(vAlbumObj)) {
					// Tạo mới order
					createAlbum(vAlbumObj);
				}
			}
			// hàm thu thập thông tin để create order
			function getCreateData(paramObj) {
				paramObj.albumCode = $("#input-album-code").val();
				paramObj.albumName = $("#input-album-name").val();
				paramObj.moTa = $("#input-note").val();
			}
			function kiemtraCreateData(paramObj) {
				if (paramObj.albumCode == "") {
					alert("Bạn điền mã Album không hợp lệ")
					return false;
				}
				if (paramObj.albumName == "") {
					alert("Bạn điền tên Album không hợp lệ")
					return false;
				}
				return true;
			}
			//Hàm tạo đơn mói
			function createAlbum(paramObj) {
				$.ajax({
					url: "http://localhost:8080/albums/create",
					type: 'POST',
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (paramObjVoucher) {
						//hiển thị dữ liệu lên web
						console.log(paramObjVoucher);
						onPageLoading();
						alert("Bạn tạo thành công Album");
						$("#input-album-code").val("");
						$("#input-album-name").val("");
						$("#input-note").val("");
					},
					error: function (error) {
						alert("Bạn tạo  Album thất bại!");
						console.log(error.responseText)
					}
				});
			}
			// infoFunction sẽ là function các nút cùng gọi
			function onButtonChiTietClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gAlbum_code.id = vOrderData.id;
				// lấy api để load vào modal
				getAlbumbyVoucherID();
				$("#update-album-modal").modal("show");
			}
			function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gAlbum_code.id = vOrderData.id;
				// lấy api để load vào modal
				$("#delete-confirm-modal").modal("show");
			}
			function onBtnPicturesConfirmOrderClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gAlbum_code.id = vOrderData.id;
				// location trang mới
				var vUrlSiteToOpen = "picture_crud .html" +
					"?id=" + gAlbum_code.id;
				window.location.href = vUrlSiteToOpen;

			}
			function getAlbumbyVoucherID() {
				$.ajax({
					url: "http://localhost:8080/albums/details/" + gAlbum_code.id,
					type: "GET",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						loadDataToModal(responseObject);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm load data to modal update
			function loadDataToModal(paramResponseObject) {
				$("#input-update-maalbum").val(paramResponseObject.albumCode);
				$("#input-update-tenalbum").val(paramResponseObject.albumName);
				$("#input-update-moTa").val(paramResponseObject.moTa);
			}
			// khi bấm nút Update trên modal
			function onBtnUpdateClick() {
				console.log(gAlbum_code.id);
				//khai báo dữ liệu
				var vObjectRequest = {
					albumCode: "",
					albumName: "",
					moTa: "",
				}
				// gán dữ liệu
				vObjectRequest.albumCode = $("#input-update-maalbum").val();
				vObjectRequest.albumName = $("#input-update-tenalbum").val();
				vObjectRequest.moTa = $("#input-update-moTa").val();
				//validate
				var validate = IstrangThai(vObjectRequest);
				if (validate) {
					//cập nhật trạng thái
					updateAlbum(vObjectRequest);
				}
			}
			function IstrangThai(paramObj) {
				if (paramObj.albumCode == "") {
					alert("Bạn điền mã Album không hợp lệ")
					return false;
				}
				if (paramObj.albumName == "") {
					alert("Bạn điền tên Album không hợp lệ")
					return false;
				}
				return true;
			}
			//update Voucher
			function updateAlbum(paramObj) {
				$.ajax({
					url: "http://localhost:8080/albums/update/" + gAlbum_code.id,
					type: "PUT",
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						handleUpdatetSuccess(responseObject.id);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm xử lý sự kiện delete order modal click
			function onBtnDeleteVoucherClick() {
				//khai báo dữ liệu
				//validate
				//gọi api
				$.ajax({
					url: "http://localhost:8080/albums/delete/" + gAlbum_code.id,
					type: "DELETE",
					contentType: "application/json; charset=utf-8",
					success: function (paramRes) {
						// B4: xử lý front-end
						handleDeleteVoucherSuccess();
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					}
				});
				//hiển thị thông tin
			}
			// hàm xử lý hiển thị front-end khi update Trạng thái thành công
			function handleUpdatetSuccess(paramObj) {
				onPageLoading();
				alert("Update Album Id = " + paramObj + " thành công!");
				$("#update-album-modal").modal("hide");
			}
			// hàm xử lý hiển thị front-end khi sửa voucher thành công
			function handleDeleteVoucherSuccess() {
				onPageLoading();
				alert("Xóa Album thành công!");
				$("#delete-confirm-modal").modal("hide");
			}


		});

	</script>
</body>

</html>